/*---------------------------------------------------------------------------
 * BMPSAVER_Color ʏ
 * bscscr.c (2000/12/12 - 2000/12/14)
 * Copyright (c) 2000, Kazuhide Hatsuyama, All rights reserved.
 *   mail    : hat@lares.dti.ne.jp
 *   HomePage: http://www.lares.dti.ne.jp/~hat/
 *---------------------------------------------------------------------------*/

#define BIOS_INLINE

#include <sys/bios.h>
#include <sys/libwwc.h>
#include <stdio.h>

#include "bsbmp_u.h"
#include "bscbmp_u.h"
#include "bscscr_u.h"
#include "bmpsaver.h"

/* Bits Per Pixel */
#define KH_BS_BPP_MONO	4
#define KH_BS_BPP_COLOR	8

/*--------------------------------------------------------------------*/
/* BMPt@Cɕۑ iOo[WƂ̌݊j*/
int bsc_save_bmp(const char far *fn, int x, int y, int w, int h)
{
	return bsc_save_screen(fn, x, y, w, h);
}

/*--------------------------------------------------------------------*/
/* BMPt@Cɕۑ */
int bsc_save_screen(const char far *fn, int x, int y, int w, int h)
{
	static BMPFILEINFO bfi;
	int src_x, src_y;
	unsigned short lcd_indicator = 0x0020;
	unsigned char color_mode;

	/* XJ[H */
	if(wwc_get_hardarch()!=HARDARCH_WSC) return KH_BS_ERROR;
	color_mode = wwc_get_color_mode();

	/* CWP[^_ */
	lcd_set_segments(lcd_indicator);

	/* BMPt@Cwb_[ */
	if(color_mode==COLOR_MODE_GRAYSCALE) {
		bs_bmp_init_header(w, h);
		bfi.bpp = KH_BS_BPP_MONO;
	} else {
		bsc_bmp_init_header(w, h);
		bfi.bpp = KH_BS_BPP_COLOR;
	}

	/* J */
	bfi.fn = fn;
	bfi.w = w;
	bfi.h = h;
	if(!bs_open(&bfi))
	{
		return KH_BS_ERROR;
	}

	/* ʏ擾 */
	bsc_screen_init_info();

	/* 摜f[^ */
	for(src_y=y+h-1;src_y>=y;src_y--)
	{
		/* CWP[^_ */
		lcd_indicator = (lcd_indicator+0x0020)&0x0020;
		lcd_set_segments(lcd_indicator);
		for(src_x=x;src_x<x+w;src_x++)
		{
			bs_putcolor(bsc_screen_get_color(src_x, src_y));
		}
	}

	/* I */
	lcd_set_segments(0);
	bs_close();
	return KH_BS_OK;
}
